#include <mega8.h>
#include <delay.h>
#include <stdio.h> 

#define ADC_VREF_TYPE 0x00;

unsigned int result;
unsigned char num_ch=0;

interrupt [ADC_INT] void adc_isr(void){

 result=ADCW; 
 printf("result=%d ",result);
 printf("number of channel=%d",num_ch);
 putchar(0x0D);
 delay_ms(20);
 num_ch++;
 if (num_ch>5) num_ch=0;
 ADMUX=num_ch;
 ADCSRA|=0x40;
 }

void init(void){

 ADCSRA=0b11011110;
 ADMUX=num_ch;
 DDRD=0xff;
 PORTB=0x00;
 UCSRB = 0x00; //disable while setting baud rate
 UCSRA = 0x00;
 UCSRC = 0x86;
 UBRRL = 0x0C; //set baud rate lo
 UBRRH = 0x00; //set baud rate hi
 UCSRB = 0x08;
 #asm ("sei");

 }

void main(void)
{
 init();
 while(1){
  }
 }